<?php
class ControllerExtensionPaymentFlowServipag extends Controller {
	private $error = array();

	public function index() {
		
		$this->load->language('extension/payment/flow_servipag');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');
		
		$privData = $this->getData();
		$privData['flow_servipag_privatekey'] = $this->config->get('flow_servipag_privatekey');
		
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate($privData)) {
			$config = $this->request->post;
			if ($this->privateKeyData) {
				$config['flow_servipag_privatekey'] = $this->privateKeyData;
			} else {
				$config['flow_servipag_privatekey'] = $privData['flow_servipag_privatekey'];
			}
			
			$this->model_setting_setting->editSetting('flow_servipag', $config);

			$this->session->data['success'] = $this->language->get('text_success');
			
			$url = $this->url->link('extension/payment/flow_servipag', 'token=' . $this->session->data['token'], 'SSL');
			if ($this->isVersion1()) {
				$this->redirect($url);
			} else {
				$this->response->redirect($url);
			}
		}

		$this->setTranslations($privData);
		$this->setErrorInfo($privData);
		$this->setBreadcrumbs($privData);
		$this->updateEditors($privData);
		
		if (isset($this->session->data['success'])) {
			$privData['success'] = $this->session->data['success'];
		
			unset($this->session->data['success']);
		} else {
			$privData['success'] = '';
		}
		
		$flow_servipag_skip_types = array();
		$flow_servipag_skip_types[] = array('id' =>'d', 'name'=>'Ingresar directamente a Servipag');
		$flow_servipag_skip_types[] = array('id' =>'f', 'name'=>'Mostrar pasarela Flow');
		$privData['flow_servipag_skip_types'] = $flow_servipag_skip_types;
		
		$privData['action'] = $this->url->link('extension/payment/flow_servipag', 'token=' . $this->session->data['token'], 'SSL');

		$privData['cancel'] = $this->url->link('extension/payment/flow_servipag', 'token=' . $this->session->data['token'], 'SSL');


		$this->load->model('localisation/order_status');
		$privData['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		$this->load->model('localisation/geo_zone');
		$privData['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
		
		if ($this->isVersion1()) {
			$this->data = $privData;
			$this->template = 'extension/payment/flow_servipag.tpl';
			$this->children = array(
				'common/header',
				'common/footer'
			);
	
			$this->response->setOutput($this->render());
		} else {
			$privData['header'] = $this->load->controller('common/header');
			$privData['footer'] = $this->load->controller('common/footer');
			$privData['column_left'] = $this->load->controller('common/column_left');
			$this->response->setOutput($this->load->view('extension/payment/flow2_servipag.tpl', $privData));
		}
	}
	
	
	private function updateEditors(&$privData) {
		$this->updateEditor($privData, 'flow_servipag_platform_id');
		$this->updateEditor($privData, 'flow_servipag_receiverid');
		$this->updateEditor($privData, 'flow_servipag_title');
		$this->updateEditor($privData, 'flow_servipag_completed_status_id');
		$this->updateEditor($privData, 'flow_servipag_failed_status_id');
		$this->updateEditor($privData, 'flow_servipag_geo_zone_id');
		$this->updateEditor($privData, 'flow_servipag_status');
		$this->updateEditor($privData, 'flow_servipag_sort_order');
		$this->updateEditor($privData, 'flow_servipag_skip_type_id');
	}
	
	private function setTranslations(&$privData) {
		$privData['heading_title'] = $this->language->get('heading_title');
		$privData['text_edit'] = $this->language->get('text_edit');
		
		$privData['text_all_zones'] = $this->language->get('text_all_zones');
		$privData['text_enabled'] = $this->language->get('text_enabled');
		$privData['text_disabled'] = $this->language->get('text_disabled');
		
		$privData['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$privData['entry_status'] = $this->language->get('entry_status');
		$privData['entry_sort_order'] = $this->language->get('entry_sort_order');
		
		$privData['entry_receiverid'] = $this->language->get('entry_receiverid');
		$privData['entry_title'] = $this->language->get('entry_title');
		$privData['entry_secret'] = $this->language->get('entry_secret');
		$privData['entry_completed_status'] = $this->language->get('entry_completed_status');
		$privData['entry_failed_status'] = $this->language->get('entry_failed_status');
		$privData['entry_type'] = $this->language->get('entry_type');
		$privData['entry_skip_type'] = $this->language->get('entry_skip_type');
		
		$privData['placeholder_receiverid'] = $this->language->get('placeholder_receiverid');
		$privData['placeholder_title'] = $this->language->get('placeholder_title');
		$privData['tip_status_complete'] = $this->language->get('tip_status_complete');
		$privData['tip_status_failed']   = $this->language->get('tip_status_failed');
		
		$privData['flow_servipag_type_default'] = $this->language->get('type_default');
		
		$privData['entry_platform'] = $this->language->get('entry_platform');
		$privData['flow_servipag_test_site'] = $this->language->get('flow_test_site');
		$privData['flow_servipag_site'] = $this->language->get('flow_site');
		
		$privData['button_save'] = $this->language->get('button_save');
		$privData['button_cancel'] = $this->language->get('button_cancel');
		
		$privData['has_private_key'] = $this->language->get('has_private_key');
	}
	
	private function setErrorInfo(&$privData) {
		$this->handleError($privData, 'warning');
		$this->handleError($privData, 'receiverid');
		$this->handleError($privData, 'title');
		$this->handleError($privData, 'privatekey');
		$this->handleError($privData, 'type');
	}
	
	private function setBreadcrumbs(&$privData) {
		$privData['breadcrumbs'] = array();
		$this->addBreadCrumb($privData, 'text_home', 'common/home', false);
		$this->addBreadCrumb($privData, 'text_payment', 'extension/payment', ' :: ');
		$this->addBreadCrumb($privData, 'heading_title', 'extension/payment/flow_servipag', ' :: ');
	}

	private function isValidPrivateKey($privateKeyFile) {
		$fp = fopen($privateKeyFile, "r");
		$priv_key = fread($fp, 8192);
		fclose($fp);
		return openssl_get_privatekey($priv_key)!=null;
	}
	
	private function validate($privData) {
		if (!$this->user->hasPermission('modify', 'extension/payment/flow_servipag')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['flow_servipag_receiverid']) {
			$this->error['receiverid'] = $this->language->get('error_receiverid');
		}
        
		if (!$this->request->post['flow_servipag_title']) {
			$this->error['title'] = $this->language->get('error_title');
		}
		
		$hasFile = false;
        if (isset($_FILES['flow_servipag_privatekey_file'])) {
        	$file = $_FILES['flow_servipag_privatekey_file'];
        	$hasFile = $file['size']>0;
        	if ($hasFile) {
        		$fileName = $file['tmp_name'];
        		if (!$this->isValidPrivateKey($fileName)) {
        			$this->error['privatekey'] = $this->language->get('error_privatekey_invalid');
        		} else {
        			$this->privateKeyData = file_get_contents($fileName);
        		}
        	}
        } 
        
        if (!isset($privData['flow_servipag_privatekey']) && !$hasFile) {
        	$this->error['privatekey'] = $this->language->get('error_privatekey');
        }
        
		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}
	
	// Utility functions
	
	private function handleError(&$privData, $type) {
		if (isset($this->error[$type])) {
			$privData['error_'.$type] = $this->error[$type];
		} else {
			$privData['error_'.$type] = '';
		}
	}

	private function addBreadCrumb(&$privData, $title, $link, $separator) {
		$privData['breadcrumbs'][] = array(
				'text'      => $this->language->get($title),
				'href'      => $this->url->link($link, 'token=' . $this->session->data['token'], 'SSL'),
				'separator' => $separator
		);
	}

	private function updateEditor(&$privData, $editor) {
		if (isset($this->request->post[$editor])) {
			$privData[$editor] = $this->request->post[$editor];
		} else {
			$privData[$editor] = $this->config->get($editor);
		}
	}
	
	private function getData() {
		if ($this->isVersion1()) {
			return $this->data;
		}
		return array();
	}
	
	private function isVersion1() {
		return version_compare(VERSION, '2.0.0.0', '<');
	}
}
?>
